		LIST P = 16F628A
		;__config	0x0106	;palabra de configuracion 16f628A codigo protegido, eepron editable, HS 20MHZ, hay que borrar previamente el chip para grabarlo con esta opcin 
		;__config	0x0146	;palabra de configuracion 16f628A codigo protegido, eepron editable, HS 20MHZ, BODEM 
		;__config	0x2106	;palabra de configuracion 16f628A codigo no protegido 20MHZ
		;__config	0x2114	;palabra de configuracion 16f628A codigo no protegido 4MHZ INTOSC-I/O 
		;__config	0x1F10	;palabra de configuracion 16f628A codigo protegido 4MHZ INTOSC-I/O, NO watch dog
		__config	0x1114	;palabra de configuracion 16f628A codigo protegido 4MHZ INTOSC-I/O
		;__config	0x3F54	;palabra de configuracion 16f628A codigo no protegido 4MHZ, BODEM
		;__config	0x0145	;palabra de configuracion 16f628A codigo protegido 4MHZ, BODEM
		;__config	0x3D14	;palabra de configuracion 16f628
		;   Set User ID Memory
		__idlocs	0x000c	;
		RADIX HEX
;PROGRAMA:   Control de paso a nivel para maquetas 
;sintesix    AMANDO VELAZQUEZ SANCHEZ agosto/2011  
;Hardware			 led desactivacion barrera RA2    1--_--18 RA1 led de activacion barrera																			
;                    		libre			   RA3    2     17 RA0 _led indicador rojo y R/S (0 instruccion) (1 caracter)
;                   		libre			   RA4    3     16 RA7 _detector de paso 2 activos a nivel bajo
;                           _pulsador stop	   RA5    4     15 RA6 _detector de paso 1  
;                                              VSS 0v 5     14 Vdd +5v
;               			libre			   RB0    6     13 RB7 led seal 4
;                           libre              RB1/RX 7     12 RB6 led seal 3	
;                           libre			   RB2/TX 8     11 RB5 led seal 2
;                           servo barreras	   RB3    9-----10 RB4 led seal 1							
;       Register Definitions
;==========================================================================
W                            EQU     H'0000'
F                            EQU     H'0001'
;----- Register Files------------------------------------------------------
INDF                         EQU     H'0000'
TMR0                         EQU     H'0001'
PCL                          EQU     H'0002'
STATUS                       EQU     H'0003'
FSR                          EQU     H'0004'
PORTA                        EQU     H'0005'
PORTB                        EQU     H'0006'
PCLATH                       EQU     H'000A'
INTCON                       EQU     H'000B'
PIR1                         EQU     H'000C'
TMR1L                        EQU     H'000E'
TMR1H                        EQU     H'000F'
T1CON                        EQU     H'0010'
TMR2                         EQU     H'0011'
T2CON                        EQU     H'0012'
CCPR1L                       EQU     H'0015'
CCPR1H                       EQU     H'0016'
CCP1CON                      EQU     H'0017'
RCSTA                        EQU     H'0018'
TXREG                        EQU     H'0019'
RCREG                        EQU     H'001A'
CMCON                        EQU     H'001F'
OPTION_REG                   EQU     H'0081'
TRISA                        EQU     H'0085'
TRISB                        EQU     H'0086'
PIE1                         EQU     H'008C'
PCON                         EQU     H'008E'
PR2                          EQU     H'0092'
TXSTA                        EQU     H'0098'
SPBRG                        EQU     H'0099'
EEDATA                       EQU     H'009A'
EEADR                        EQU     H'009B'
EECON1                       EQU     H'009C'
EECON2                       EQU     H'009D'
VRCON                        EQU     H'009F'
;----- STATUS Bits --------------------------------------------------------
IRP                          EQU     H'0007'
RP1                          EQU     H'0006'
RP0                          EQU     H'0005'
NOT_TO                       EQU     H'0004'
NOT_PD                       EQU     H'0003'
Z                            EQU     H'0002'
DC                           EQU     H'0001'
C                            EQU     H'0000'
;----- INTCON Bits --------------------------------------------------------
GIE                          EQU     H'0007'
PEIE                         EQU     H'0006'
T0IE                         EQU     H'0005'
INTE                         EQU     H'0004'
RBIE                         EQU     H'0003'
T0IF                         EQU     H'0002'
INTF                         EQU     H'0001'
RBIF                         EQU     H'0000'
;----- PIR1 Bits ----------------------------------------------------------
EEIF                         EQU     H'0007'
CMIF                         EQU     H'0006'
RCIF                         EQU     H'0005'
TXIF                         EQU     H'0004'
CCP1IF                       EQU     H'0002'
TMR2IF                       EQU     H'0001'
TMR1IF                       EQU     H'0000'
;----- T1CON Bits ---------------------------------------------------------
T1CKPS1                      EQU     H'0005'
T1CKPS0                      EQU     H'0004'
T1OSCEN                      EQU     H'0003'
NOT_T1SYNC                   EQU     H'0002'
TMR1CS                       EQU     H'0001'
TMR1ON                       EQU     H'0000'
;----- T2CON Bits ---------------------------------------------------------
TOUTPS3                      EQU     H'0006'
TOUTPS2                      EQU     H'0005'
TOUTPS1                      EQU     H'0004'
TOUTPS0                      EQU     H'0003'
TMR2ON                       EQU     H'0002'
T2CKPS1                      EQU     H'0001'
T2CKPS0                      EQU     H'0000'
;----- CCP1CON Bits ---------------------------------------------------------
CCP1X                        EQU     H'0005'
CCP1Y                        EQU     H'0004'
CCP1M3                       EQU     H'0003'
CCP1M2                       EQU     H'0002'
CCP1M1                       EQU     H'0001'
CCP1M0                       EQU     H'0000'
;----- RCSTA Bits ---------------------------------------------------------
SPEN                         EQU     H'0007'
RX9                          EQU     H'0006'
SREN                         EQU     H'0005'
CREN                         EQU     H'0004'
ADEN                         EQU     H'0003'
FERR                         EQU     H'0002'
OERR                         EQU     H'0001'
RX9D                         EQU     H'0000'
;----- CMCON Bits ---------------------------------------------------------
C2OUT                        EQU     H'0007'
C1OUT                        EQU     H'0006'
C2INV                        EQU     H'0005'
C1INV                        EQU     H'0004'
CIS                          EQU     H'0003'
CM2                          EQU     H'0002'
CM1                          EQU     H'0001'
CM0                          EQU     H'0000'
;----- OPTION Bits --------------------------------------------------------
NOT_RBPU                     EQU     H'0007'
INTEDG                       EQU     H'0006'
T0CS                         EQU     H'0005'
T0SE                         EQU     H'0004'
PSA                          EQU     H'0003'
PS2                          EQU     H'0002'
PS1                          EQU     H'0001'
PS0                          EQU     H'0000'
;----- PIE1 Bits ----------------------------------------------------------
EEIE                         EQU     H'0007'
CMIE                         EQU     H'0006'
RCIE                         EQU     H'0005'
TXIE                         EQU     H'0004'
CCP1IE                       EQU     H'0002'
TMR2IE                       EQU     H'0001'
TMR1IE                       EQU     H'0000'
;----- PCON Bits ----------------------------------------------------------
OSCF                         EQU     H'0003'
NOT_POR                      EQU     H'0001'
NOT_BO                       EQU     H'0000'
NOT_BOR                      EQU     H'0000'
NOT_BOD                      EQU     H'0000'
;----- TXSTA Bits ----------------------------------------------------------
CSRC                         EQU     H'0007'
TX9                          EQU     H'0006'
TXEN                         EQU     H'0005'
SYNC                         EQU     H'0004'
BRGH                         EQU     H'0002'
TRMT                         EQU     H'0001'
TX9D                         EQU     H'0000'
;----- EECON1 Bits ---------------------------------------------------------
WRERR                        EQU     H'0003'
WREN                         EQU     H'0002'
WR                           EQU     H'0001'
RD                           EQU     H'0000'
;----- VRCON Bits ---------------------------------------------------------
VREN                         EQU     H'0007'
VROE                         EQU     H'0006'
VRR                          EQU     H'0005'
VR3                          EQU     H'0003'
VR2                          EQU     H'0002'
VR1                          EQU     H'0001'
VR0                          EQU     H'0000'
						;---------------------------------------------------------------------------------------------
		ORG 	0		;Reset
		goto 	inicio
		nop
		nop
		nop
		ORG		4		;Vector de interupcion
		movwf	0x24	;descarga W en la variable 0x24
		swapf	STATUS,W ;swap status register into W register
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		movwf	0x21    ;guarda el registro STATUS en la variable 0x21 banco 0
		call	rsi		;llama a la rutina de interrupciones
		swapf	0x21,W	;swap variable STATUS a W vuelve al banco original
		movwf	STATUS  ;restaura pre-isr STATUS 
		swapf   0x24,F	;necesario para no afectar el flag Z
		swapf   0x24,W  ;restaura el contenido del registro W
		retfie          ;retorno de la rutina de interrupciones
rsi		clrwdt			;rutinas de servicio a las interrupciones*********************************
		btfsc	PIR1,5	;si RCIF=0 brinca
		goto	IRCIF	;llama a la rutina de interrupcion RCIF Int Recepcion USART 
		btfsc	PIR1,4	;si TXIF=0 brinca
		goto	ITXIF	;llama a la rutina de interrupcion TXIF Int Transmision USART 
		btfsc	PIR1,7	;si EEIF=0 brinca
		goto	IEEIF	;llama a la rutina de interrupcion EEIF Int escritura eeprom
		btfsc	INTCON,1	;si INTF=0 brinca
		goto	IINTE	;llama a la rutina de interrupcion INTE Interrupcion exterior
		btfsc	INTCON,0	;si RBIF=0 brinca
		goto	IRBIF	;llama a la rutina de interrupcion RBIF Int Puerto B cambio de estado
		btfsc	PIR1,6	;si CMIF=0 brinca
		goto	ICMIF	;llama a la rutina de interrupcion CMIF Int comparador
		btfsc	PIR1,2	;si CCP1IF=0 brinca
		goto	IC1IF	;llama a la rutina de interrupcion C1IF Int comparador 1
		btfsc	INTCON,2	;si TOIF=0 brinca
		goto	ITMR0I	;llama a la rutina de interrupcion TMR0I Int por TMR0 
		btfsc	PIR1,0	;si TMR1IF=0 brinca
		goto	ITMR1I	;llama a la rutina de interrupcion TMR1I Int TMR1 
		btfsc	PIR1,1	;si TMR2IF=0 brinca
		goto	ITMR2I	;llama a la rutina de interrupcion TMR2I Int TMR2 
		return
IRCIF	movf 	RCREG,W ;lectura del dato en el registro de la USART el dato esta en W listo para usar------------------
		movwf	0x37	;deja el dato recibido por la USART en esta variable
		return
ITXIF	return          ;retorno de la rutina de transmision rutinas de interrupcion
ICMIF	bcf		PIR1,6	;poner flag a 0
		return
IC1IF	bcf		PIR1,2	;poner flag a 0
		return
ITMR0I	movf	PORTB,W	;puerto B a w las lineas sigientes conmutan los led B4 y B5 b6 y b7 on/off en cada pasada ----------
		movwf	0x2b	;w a variable 0x2b
		movlw	0xf0	;carga w con la mascara 11110000
		xorwf	0x2b,W	;w xor f a w
		movwf	PORTB	;w a puerto B      ---------------------		
		incf	0x35,F	;la variable 0x35 se incrementa cada interrupcion de TMR0
		bcf		INTCON,2	;poner flag a 0
		return
ITMR1I	;btfsc	0x36,0	;chequea bit 0 de la variable 0x36 (lineas complementarias a la rutina reloj calendario)----------------
		;goto 	salto2 	;si = 0 sale 
		;btfsc	0x36,1	;chequea bit 1 de la variable 0x36  
		;goto 	salto2  ;si = 0 sale  
		;clrf	0x3a	;pone a 0 la variable 0x3a cada 4 rutinas de interrupcion TMR1I 16 rutinas = 1seg contador ticks/pulsos
		;bsf		0x2d,5	;pone a 1 el flag para sealizar 1 segundo
;salto2	incf	0x36,F	;la variable 0x36 se incrementa cada interrupcion de TMR1
;		movlw	0x0b	;carga W con la parte alta de la correccion para TMR1 0e (lineas incompatibles con el PWM por software, reescriben TMR1)
;		movwf	TMR1H	;lo descarga en TMR1H
;		movlw	0xd0	;carga w con la parte baja de la correccion para TMR1 55 (PARA MEJORAR LA PRECISION DEL RELOJ EN CADA CASO PARA CADA CHIP)
;		addwf	0x70,W	;suma a W el ajuste del reloj 
;		movwf	TMR1L	;lo descarga en L
  	    bcf		PIR1,0	;poner flag a 0
		return
ITMR2I	bcf		PIR1,1	;poner flag a 0
		return
IINTE	bcf 	STATUS,C ; borra el bit de acarreo
 		incf	0x77,F	;la variable L de el contador de interrupciones por RB0/INT se incrementa
		btfsc	STATUS,C	;chequea si hay acarreo e incrementa el contador H si lo hay
		incf	0x78,F	;la variable H de el contador de interrupciones por RB0/INT se incrementa
		bcf		INTCON,1	;poner flag a 0
		return
IRBIF	bcf		INTCON,0	;poner flag a 0
		return
IEEIF	bcf		PIR1,7	;poner flag a 0
		return			;fin de rutinas de interrupcion----------------------------------------------------------
inicio	clrwdt          ;-----------------------------------------------------------------------------------------
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		clrf	INTCON	;W a INTCON prohibe todas las interupciones
		movlw	0x05	;prescaler de TMR1 es 1:1 (0=1:1,1=1:2,2=1:4,3=1:8) en la primera cifra (TMR1 desactivado)
		movwf	T1CON	;W a T1CON valores por defecto
		movlw	0x0c	;valor por defecto para CCP1CON OJO (PWM activado)
		movwf	CCP1CON	;W a CCP1CON valores por defecto
		bcf		CCP1CON,CCP1Y	;pone a 0 el bit lsb del duty cycle
		bcf		CCP1CON,CCP1X	;pone a 0 el segundo bit lsb del duty cycle
		movlw	0x0F	;valor por defecto para CCPR1L
		movwf	CCPR1L	;W a CCPR1L valor por defecto para el duty cycle del PWM
		movlw	0x04	;valor por defecto para T2CON (TMR2 activado con preescaler 1:1)
		movwf	T2CON	;W a T2CONN valor por defecto
		clrf	RCSTA	;W a RCSTA valor por defecto
		movlw	0x07	
		movwf	CMCON	;apagar comparadores
		bsf		STATUS,5
		bcf		STATUS,6	;BANCO1
		bcf		PCON,OSCF;Este bit pone la frecuencia de clock interno R/C a 4MHZ si esta a 1 y a 48Khz si esta a 0
		movlw	0x99	;valor por defecto para PR2 (20ms de periodo para el PWM con ckl 37Khz y preescaler 1:1)
		movwf	PR2		;W a PR2 valor por defecto al incio de programa
		movlw	0x82	;85 a W preescaler TMR0 011 1:8, INT/RB0 1 to 0
		movwf	OPTION_REG	;W al registro OPTION valores por defecto
		movlw	0xa0	;a0 a W
		movwf	TXSTA	;W a TXSTA valores por defecto
		clrf	PIE1	;W a PIE1 prohibe las interupciones de perifericos 
		clrf	VRCON	;W a VRCON valores por defecto
		movlw	0xe0	;e0 a W 
		movwf	TRISA	;TRISA A 11100000 1=entrada 0=salida
		movlw 	0x00	;00 a W
		movwf	TRISB	;TRISB B 00000000
		movlw 	0x07 	;valor para el registro BRG  configura la USART 0x07 si clock 4MHZ, 0x09 si 20MHZ-------
        movwf 	SPBRG 	;inicializa el registro BRG con la velocidad de 31250 bauds
        bcf		TXSTA,BRGH	;pone a 1 el bit BRGH DEBE SER 1 CON 4MHZ CKL
		bcf 	TXSTA,SYNC	;pone a 0 el bit SYNC se pone en modo asncrono
        bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		bcf 	RCSTA,SPEN	;activa o desactiva los pines B1 y B2 para la USART RX/TX
        movlw	0xe6	;valores de inicio para el puerto A 
		movwf	PORTA	
		movlw	0xf0	;valores de inicio para el puerto B 
		movwf	PORTB
		clrf	FSR		;inicializa el registro FSR
		clrf	0x20	;variable para guardar el registro INTCON valores de inicio para las variables---------------------------------------------------
		clrf	0x21	;variable para guardar STATUS 
		clrf	0x22	;variable delay bucle corto
		clrf	0x23	;variable delay bucle largo
		clrf	0x24	;variable para guardar W 
		clrf	0x25	;variable para guardar dato eeprom
		clrf	0x26	;variable factor de velocidad subir bajar,
		clrf	0x27	;variable direccion EEADR (contiene la direccion de la eeprom a leer o grabar)
		clrf	0x28	;variable 0x28 DATO EEDATA 
		clrf	0x29	;variable memoria de programa en curso al arrancar
		clrf	0x2a	;variable de trabajo proposito general repeticion de ciclos
		clrf	0x2b	;variable de trabajo proposito general 
		clrf	0x2c	;variable de trabajo proposito general flag 0 
		clrf	0x2d	;variable de trabajo proposito general usada para flag de bits 0=habilita puerto B/TMR1 1=indica primer dato midi 2=indica segundo dato midi  	
		;																			3=indica ruido de caja a data3 4=indica ACTIVAR ESCRITURA en EEPROM
		;																			5=flag para sealizar 1 segundo en la interrupcion de TIMER1
		;																			6=flag para sealizar error en la escritura de eeprom
		clrf	0x2e	;variable memoria de tiempo
		clrf	0x2f	;variable valor de tecla pulsada
		clrf	0x30	;variable numero binario para codificacion bcd
		clrf	0x31	;variable unidades para codificacion bcd
		clrf	0x32	;variable decenas para codificacion bcd
		clrf	0x33	;variable centenas para codificacion bcd
		clrf	0x34	;variable millares para codificacion bcd
		clrf	0x35	;variable contador Interrupciones TMR0
		clrf	0x36	;variable contador Interrupciones TMR1
		clrf	0x37	;variable dato midi recibido USART
		clrf	0x38	;variable bite de stado midi 	 
		clrf	0x39	;variable canal midi swap	
		clrf	0x3a	;variable tmr1I ticks
		clrf	0x3b	;variable tipo de sysex
		clrf	0x3c	;variable segundo dato midi
		clrf	0x3d	;variable tercer dato midi
		clrf	0x3e	;variable ultimo tipo de controlador midi recibido
		clrf	0x3f	;variable numero pseudorandom RND
		clrf	0x40	;variable trigger 0	y motor PAP bobinas
		clrf	0x41	;variable duragion trigger 1, retardo antirrebote reeds PNL
		clrf	0x42	;variable duragion trigger 2
		clrf	0x43	;variable duragion trigger 3
		clrf	0x44	;variable duragion trigger 4
		clrf	0x45	;variable duragion trigger 5
		clrf	0x46	;variable duragion trigger 6
		clrf	0x47	;variable duragion trigger 7
		clrf	0x48	;variable duragion trigger 8
		clrf	0x49	;variable duragion trigger 9
		clrf	0x4a	;variable duragion trigger 10
		clrf	0x4b	;variable    
		clrf	0x4c	;variable   
		clrf	0x4d	;variable  
		clrf	0x4e	;variable  
		clrf	0x4f	;variable   
		clrf	0x50	;variable duracion envolvente ruido de caja   
		clrf	0x51	;variable tiempo segundos   
		clrf	0x52	;variable tiempo minutos   
		clrf	0x53	;variable tiempo horas
		clrf	0x54	;variable tiempo dia del mes
		clrf	0x55	;variable tiempo mes
		clrf	0x56	;variable tiempo ao
		clrf	0x57	;variable tiempo de trabajo
		clrf	0x58	;variable lcd_print
		clrf	0x60	;variable que cuenta las puestas en marcha 
		movlw	0x01	;carga W con 1 el valor de incremento/decremento de las rutinas subir y bajar
		movwf	0x61	;variable incremento
		movwf	0x62	;variable decremento
		movlw	0x3c	;poner aqu maximo valor admitido por la rutina subir
		movwf	0x63	;descarga W en la variable
		movlw	0x00	;poner aqu minimo valor admitido por la rutina bajar
		movwf	0x64	;descarga W en la variable		
		clrf	0x65	;valor primero rutina de carga en bloque rc_bloque y carga_bloque
		clrf	0x66	;valor ultimo rutina de carga en bloque rc_bloque y carga_bloque
		clrf	0x67	;operando_A para operaciones matematicas 
		clrf	0x68	;operando_B para operaciones matematicas
		clrf	0x69	;resultado para las operaciones entre operando_A y operando_B
		clrf	0x70	;variable tiempo ajuste del reloj en la rutina TMR1I   
		clrf	0x71	;variable tiempo evento on segundos, PWM valor minimo para CCPR1L   
		clrf	0x72	;variable tiempo evento on minutos, PWM valor de arranque para CCPR1L   
		clrf	0x73	;variable tiempo evento on horas, PWM valor de maximo para CCPR1L
		clrf	0x74	;variable tiempo evento off segundos
		clrf	0x75	;variable tiempo evento off minutos
		clrf	0x76	;variable tiempo evento off horas, PWM valor para PR2
		clrf	0x77	;variable de incremento L rutina de interrupcin INTE
		clrf	0x78	;variable de incremento H rutina de interrupcin INTE
		clrf	0x79	;variable de divisor contador rutina de interrupcin INTE
		clrf	0x7a	;variable de contador rutina de interrupcin INTE
		clrf	0x7b	;variable preescaler TMR0
		clrf	0x7f	;ultima posicion de memoria
		movlw	0x51	;primera direccion a copiar de eeprom a ram con a la rutina rc_bloque, graba_bloque------------------------------
		movwf	0x65	;descarga W
		movlw	0x56	;ultima direccion a copiar de eeprom a ram con a la rutina rc_bloque y graba_bloque
		movwf	0x66	;rutina que copia un bloque de ram a eeprom empezando por el valor cargado en la variable 0x66
		call	rc_bloque	;y terminando en el valor cargado en la variable 0x66 ------------------------------------------
		bsf		STATUS,5	;lee de la EEPROM la variable 0x60-----------------------------------------
		bcf		STATUS,6	;BANCO1
		movlw	0x60	;direccion a leer 
		movwf	EEADR	;W a EEADR
		bsf		EECON1,0	;activar lectura eeprom
		movf	EEDATA,W ;W se carga con el dato eeprom leido
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		movwf	0x60	;W a la variable 0x60 memoria puestas en marcha
		bsf		STATUS,5	;lee de la EEPROM la variable 0x26-----------------------------------------
		bcf		STATUS,6	;BANCO1
		movlw	0x57	;direccion a leer 
		movwf	EEADR	;W a EEADR
		bsf		EECON1,0	;activar lectura eeprom
		movf	EEDATA,W ;W se carga con el dato eeprom leido
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		movwf	0x57	;W a la variable 0x57 memoria tiempo de trabajo
		bsf		STATUS,5	;lee de la EEPROM la variable 0x70----------------------------------------
		bcf		STATUS,6	;BANCO1
		movlw	0x70	;direccion a leer 
		movwf	EEADR	;W a EEADR
		bsf		EECON1,0;activar lectura eeprom
		movf	EEDATA,W ;W se carga con el dato eeprom leido
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		movwf	0x70	;W a la variable 0x70 memoria 
		bsf		STATUS,5	;lee de la EEPROM la variable 0x41----------------------------------------
		bcf		STATUS,6	;BANCO1
		movlw	0x41	;direccion a leer 
		movwf	EEADR	;W a EEADR
		bsf		EECON1,0;activar lectura eeprom
		movf	EEDATA,W ;W se carga con el dato eeprom leido
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		movwf	0x41	;W a la variable 0x41 memoria
		bsf		STATUS,5	;lee de la EEPROM la variable 0x79----------------------------------------
		bcf		STATUS,6	;BANCO1
		movlw	0x79	;direccion a leer 
		movwf	EEADR	;W a EEADR
		bsf		EECON1,0;activar lectura eeprom
		movf	EEDATA,W ;W se carga con el dato eeprom leido
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		movwf	0x79	;W a la variable 0x79 memoria de tope contador interrupciones RB0/INT
		bsf		STATUS,5	;lee de la EEPROM la variable 0x29-------------------------------------------
		bcf		STATUS,6	;BANCO1
		movlw	0x29	;direccion a leer 
		movwf	EEADR	;W a EEADR
		bsf		EECON1,0;activar lectura eeprom
		movf	EEDATA,W ;W se carga con el dato eeprom leido
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		movwf	0x29	;W a la variable 0x29 memoria de programa en curso al arrancar
		incf	0x60,W	;carga W con la variable 0x29 y la incrementa en cada arranque
		movwf	0x28	;W a 0x28 
		movlw	0x60	;direccion eeprom que se desea grabar
		movwf	0x27	;carga la variable 0x27 con la direccion 0x29	
		bsf		0x2d,4	;activa el flag de permiso de escritura en eeprom por software
		call	weep	;llama a la rutina de escritura en eeprom
		movlw	0x71	;primera direccion a copiar de eeprom a ram con a la rutina rc_bloque----------------------------------------
		movwf	0x65	;descarga W en la variable primer valor
		movlw	0x76	;ultima direccion a copiar de eeprom a ram con a la rutina rc_bloque
		movwf	0x66	;rutina que copia un bloque de eeprom a ram empezando por el valor cargado en la variable 0x65 y terminando por el valor en la 0x66
		call	rc_bloque	;y terminando en el valor cargado en la variable 0x66---------------------------------------------------- 
						;---------------inicia LCD--------------- este programa no lo utiliza
						;movlw	0x20	;valor de control para el LCD display on/off bus a 4bits
						;call	lcd_instr	;llama a la rutina de instruccion de control para el LCD
						;movlw	0x28	;valor de control para el LCD display on/off bus a 4bits
						;call	lcd_instr	;llama a la rutina de instruccion de control para el LCD
						;movlw	0x06	;valor de control para el LCD display on/off 
						;call	lcd_instr	;llama a la rutina de instruccion de control para el LCD
						;movlw	0x0c	;valor de control para el LCD funcion set
						;call	lcd_instr	;llama a la rutina de instruccion de control para el LCD
						;call	delay_lcd ;llama a una tenporizacion corta
						;call	delay_lcd ;llama a una tenporizacion corta
						;call	delay_lcd ;llama a una tenporizacion corta
		movlw	0x03	;veces que se repite el ciclo******************El PROGRAMA COMIENZA AQUI*******************************
		movwf	0x2a		
cicloi	clrwdt
		movlw	0xff	;carga valor para delay corto
		movwf	0x23
		call	delay
		bcf		PORTA,0	;enciende led A0     rutina que enciende  y apaga el led A0	
		movlw	0xf0	;carga valor para delay corto
		movwf	0x23
		call	delay
		bsf		PORTA,0	;apaga led A0	
		decfsz	0x2a,F	;si la variable 0x2a es 0 salta y continua
		goto	cicloi	;fin secuencia de led inicial a0 poner codigo a partir de aqui**************************************
						;Habilitaciones o deshabilitaciones de los perifericos y sus interrupciones o modos de trabajo----------
		bsf		STATUS,5	
		bcf		STATUS,6	;BANCO1
		bcf		VRCON,VREN	;habilita o no la tension de referencia Vref
		bcf		VRCON,VRR	;1= Vref alto rango   0= Vref bajo rango debe estar a 0 para mejor efecto
		bcf		VRCON,VROE	;habilita o no la salida de tension de referencia Vref
		bcf		PIE1,TXIE	;habilita o no la interrupcion por Transmision de datos por la USART
		bcf		PIE1,RCIE	;habilita o no la interrupcion por recepcion de datos por la USART
		bcf		TXSTA,TXEN	;habilita o no la transmision de datos por la USART
		bsf		PIE1,TMR1IE	;habilita interrupcion TMR1
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		bcf 	RCSTA,CREN  ;habilita o no la recepcion de datos por la USART
		bcf		INTCON,INTE	;habilita o no la interrupcion exterior por PORTB0
		bcf		INTCON,T0IE	;habilita o no la interrupcion por Timer0
		bcf		INTCON,PEIE	;habilita o no las interrupciones de los perifericos
		btfsc	RCSTA,OERR	;si no hay acumulacion de datos recibidos salta
		bcf		RCSTA,CREN	;en caso afirmativo resetea la USART					
		movlw	0x00	;carga w con 0
		movwf	TMR0	;carga TMR0 con w
		clrf	TMR1L	;pone a 0 el contador L TMR1
		clrf	TMR1H	;pone a 0 el contador H TMR1 --------------------------------------------------------------------------
		bsf		INTCON,GIE	;habilita o no la interrupcion global 
		;movlw	0x01	;valor de indremento y decremento para las rutinas subir y bajar
		;movfw	0x61	;variable incremento
		;movfw	0x62	;variable decremento
		;movlw	0x63	;valor maximo alcanzable para la rutina subir
		;movfw	0x63	;variable valor maximo
		;movlw	0x01	;valor minimo alcanzable para la rutina bajar
		;movfw	0x64	;variable valor minimo
		;movf	0x79,W	;carga W con la variable 0x79 divisor
		;movwf	0x26	;descarga W en la variable valor para las rutinas subir y bajar
bucle	movf	0x71,W	;carga valor para el duty cycle del PWM
		movwf	CCPR1L	;lo descarga en el registo L del duty cycle del PWM
ijn2	clrwdt
		btfss	PORTA,5	;comprueba el bit 5 del puerto A
		goto 	ijn2	;anti rrebote 
		btfss	PORTA,6	;comprueba el bit 6 del puerto A
		goto 	ijn2	;anti rrebote 
		btfss	PORTA,7	;comprueba el bit 7 del puerto A
		goto 	ijn2	;anti rrebote  no pasa si algun pulsador esta activado
		bcf		INTCON,T0IE	;habilita o no la interrupcion por Timer0
		bsf		PORTA,2	;enciende el indicador de desactivacion de la barrera
		bcf		PORTA,1	;apaga el indicador de activacion
		bcf		PORTB,4	;apaga el led de seal 1
		bcf		PORTB,5	;apaga el led de seal 2
		bcf		PORTB,6	;apaga el led de seal 3
		bcf		PORTB,7	;apaga el led de seal 4
		btfsc	PORTA,7	;comprueba el bit 7 del puerto A
		goto	cont2	;continua 
		bsf		PORTA,1	;enciende el indicador de activacion
		bsf		PORTB,4	;enciende el indicador de seal luminosa
		bsf		PORTB,6	;enciende el indicador de seal luminosa
		bcf		PORTA,2	;apaga el led de desactivacion de barrera
		bsf		INTCON,T0IE	;habilita o no la interrupcion por Timer0
		movf	0x73,W	;carga valor para duty cycle del PWM
		movwf	CCPR1L	;lo descarga en el registo L del duty cycle del PWM
cont1	clrwdt
		btfss	PORTA,5	;comprueba el bit 5 del puerto A
		goto	bucle	;sale si el boton stop en A5 es pulsado
		btfsc	PORTA,6	;comprueba el bit 6 del puerto A
		goto	cont1	;continua (entra en un bucle hasta recibir la seal de desactivacion)
		movf	0x41,W	;carga W con el valor en la variable 0x41 para un delay corto
		movwf	0x23
		call 	delay
		goto	bucle	;da la activacion por terminada y sale al bucle principal del programa
cont2	btfsc	PORTA,6	;comprueba el bit 6 del puerto A
		goto	ijn2	;continua 
		bsf		PORTA,1	;enciende el indicador de activacion
		bsf		PORTB,5	;enciende el indicador de seal luminosa
		bsf		PORTB,7	;enciende el indicador de seal luminosa
		bcf		PORTA,2	;apaga el led de desactivacion de barrera
		bsf		INTCON,T0IE	;habilita o no la interrupcion por Timer0
		movf	0x73,W	;carga valor para duty cycle del PWM
		movwf	CCPR1L	;lo descarga en el registo L del duty cycle del PWM
cont3	clrwdt
		btfss	PORTA,5	;comprueba el bit 5 del puerto A
		goto	bucle	;sale si el boton stop en A5 es pulsado
		btfsc	PORTA,7	;comprueba el bit 7 del puerto A
		goto	cont3	;continua (entra en un bucle hasta recibir la seal de desactivacion)
		movf	0x41,W	;carga W con el valor en la variable 0x41 para un delay corto
		movwf	0x23
		call 	delay
		goto	bucle	;da la activacion por terminada y sale al bucle principal del programa
		; Fin del cuerpo central del programa
								;comienzo libreria de rutinas***********************************************************************************************************************
delay_lcd				;delay muy corto para temporizacion con LCD
		movwf	0x24	;descarga W en la variable 0x24
		movlw	0xff	;valor para los 256 de mas peso
		movwf	0x23	;
		movlw	0xf8	;valor para los 256 de menor peso
		movwf	0x22	;Carga las variables para un delay muy corto
		movf	0x24,W	;restaura W
delay	clrwdt	;************************************Rutina delay
		incfsz	0x22,F	;incrementa variable 0x22
		goto	delay		;loop mientras 0x22 no sea 0		
		incfsz	0x23,F	;incrementa variable 0x23
		goto	delay		;loop mientras 0x23 no sea 0
		clrf	0x22	;borra la variable 0x22
		clrf	0x23	;borra la variable 0x23
		return			;Fin de la rutina delay******************
reloj_calendario		
		incf	0x51,F	;incrementa la variable segundos cada 4 interrupciones de TMR1 (1seg)-----------------
		movf	0x51,W	;carga W con la variable segundos
		sublw	0x3c	;W - 60
		btfss	STATUS,Z	;saltar si Z=1
		return	  		;si = 0 sale  
		clrf	0x51	;la variable segundos se resetea cuando llega a 60
		incf	0x52,F	;la variable minutos se incrementa
		movf	0x52,W	;carga W con la variable minutos
		sublw	0x3c	;W - 60
		btfss	STATUS,Z	;saltar si Z=1
		return			;si = 0 sale  
		clrf	0x52	;la variable minutos se resetea cuando llega a 60
		incf	0x53,F	;la variable horas se incrementa
		incf	0x57,F	;la variable horas de tiempo de trabajo se incrementa
		movf	0x53,W	;carga W con la variable horas
		sublw	0x18	;W - 24
		btfss	STATUS,Z	;saltar si Z=1
		return			;si = 0 sale  
		clrf	0x53	;la variable horas se resetea cuando llega a 24
		incf	0x54	;se incrementa la variable dia del mes
		call	tabla	;se llama a la tabla para saber la duracion del mes 28, 30, 31
		subwf	0x54,W	;resta el resultado de la tabla y el dia del mes
		btfss	STATUS,Z		;salta si el resultado de la operacion es 0
		return			;si no igual a 0 sale
		movlw	0x01	;carga W con 0x01 
		movwf	0x54	;pone a 1 la variable dia del mes 
		incf	0x55,F	;incrementa la variable mes
		movlw	0x0c	;carga W con una constante para saber si se desborda el mes
		subwf	0x55,W	;resta W de la variable mes
		btfss	STATUS,Z	;chekea el resultado y salta si son iguales
		return			; si no es 12 sale
		movlw	0x01	;carga W con 0x01
		movwf	0x55	;pone a 1 la variable mes si se desborda (12)	
		incf	0x56,F	;incrementa la variable ao--------------------- hasta aqui calculo de hora y fecha
		return
lcd_clear
		movlw	0x01	;valor para control de CLEAR DISPLAY-------------
		call	lcd_instr	;borra la pantalla del LCD
		call	delay_lcd ;llama a una tenporizacion corta
		call	delay_lcd ;llama a una tenporizacion corta
		call	delay_lcd ;llama a una tenporizacion corta
		return
lcd_home
		movlw	0x02	;valor para control HOME--------------------------
		call	lcd_instr  ;coloca el cursor a la primera posicion del LCD
		call	delay_lcd ;llama a una tenporizacion corta
		call	delay_lcd ;llama a una tenporizacion corta
		call	delay_lcd ;llama a una tenporizacion corta
		return
lcd_instr				;instruccion para el LCD--------------------------------
		movwf	0x58	;descarga W en la variable LCD_print
		movlw	0x0f	;mascara para el Puerto B
		andwf	PORTB,F	;borra el nibble alto
		movf	0x58,W	;carga W con el dato a enviar al LCD en dos partes
		andlw	0xf0	;trunca el dato
		iorwf	PORTB,F	;descarga el nibble alto en el Puerto B conectado al LCD
		bcf		PORTA,1	;pone el LCD en modo escritura
		bcf		PORTA,0	;pone el LCD en modo instruccion
		bsf		PORTA,4	;activa el LCD enable
		nop
		nop
		bcf		PORTA,4	;desactiva el LCD enable----------------------------
		movlw	0x0f	;mascara para el Puerto B
		andwf	PORTB,F	;borra el nibble alto
		swapf	0x58,W	;intercambia nibbles
		andlw	0xf0	;trunca el dato
		iorwf	PORTB,F	;descarga el nibble bajo en el Puerto B conectado al LCD
		bcf		PORTA,1	;pone el LCD en modo escritura
		bcf		PORTA,0	;pone el LCD en modo instruccion
		bsf		PORTA,4	;activa el LCD enable
		nop
		nop
		bcf		PORTA,4	;desactiva el LCD enable----------------------------
		call	delay_lcd ;llama a una tenporizacion corta
		return
lcd_print				;muestra un caracter en pantalla en la posicion corriente
		movwf	0x58	;descarga W en la variable LCD_print
		movlw	0x0f	;mascara para el Puerto B
		andwf	PORTB,F	;borra el nibble alto
		movf	0x58,W	;carga W con el dato a enviar al LCD en dos partes
		andlw	0xf0	;trunca el dato
		iorwf	PORTB,F	;descarga el nibble alto en el Puerto B conectado al LCD
		bcf		PORTA,1	;pone el LCD en modo escritura
		bsf		PORTA,0	;pone el LCD en modo caracter
		bsf		PORTA,4	;activa el LCD enable
		nop
		nop
		bcf		PORTA,4	;desactiva el LCD enable----------------------------
		movlw	0x0f	;mascara para el Puerto B
		andwf	PORTB,F	;borra el nibble alto
		swapf	0x58,W	;intercambia nibbles
		andlw	0xf0	;trunca el dato
		iorwf	PORTB,F	;descarga el nibble bajo en el Puerto B conectado al LCD
		bcf		PORTA,1	;pone el LCD en modo escritura
		bsf		PORTA,0	;pone el LCD en modo caracter
		bsf		PORTA,4	;activa el LCD enable
		nop
		nop
		bcf		PORTA,4	;desactiva el LCD enable----------------------------
		call	delay_lcd ;llama a una tenporizacion corta
		return
subir	clrwdt			;***********************************rutina subir
		movwf	0x24	;descarga W en la variable 0x24
		movf	0x61,W	;incremento para la variable 0x26 1 en este caso
		addwf	0x26,F	;incremento + variable a 0x26
		movf	0x26,W	;carga W con la variable 0x26
		subwf	0x63,W	;W - valor mximo para 0x26
		btfsc	STATUS,Z	;salta si Z=0
		goto	esigual		;W=F
		btfsc	STATUS,C	;chequea el bit de acarreo C y salta si el resultado de restar W de F ha sido negativo C=0
		goto	esmenor	;C=1 entonces W<F
		goto	esmayor	;C=0 entonces W>F
esigual	movf	0x63,W	;fuerza valor tope para variable 0x26
		movwf	0x26	;colocar aqui codigo para sealar maximo valor alcanzado
		goto	eesubir
esmenor	goto	eesubir
esmayor	movf	0x63,W	;fuerza valor tope para variable 0x26
		movwf	0x26	;colocar aqui codigo para sealar maximo valor alcanzado
		goto	eesubir
eesubir	clrwdt			;graba en eeprom el valor factor de velocidad
		movf	0x26,W
		movwf	0x28	;0x26 a 0x28
		movlw	0x26
		movwf	0x27	;carga la variable 0x27 con la direccion 0x26	
		call	weep
		bcf		PORTA,0	;enciende led A0	
		movlw	0xa0	;carga valor para delay corto
		movwf	0x23
		call	delay
		bsf		PORTA,0	;apaga led A0	
		return			;fin rutina subir ***********************************
bajar	clrwdt			;*****************************************rutina bajar
		movwf	0x24	;descarga W en la variable 0x24
		movf	0x62,W	;decremento para la variable 0x26 1 en este caso
		subwf	0x26,F	;decremento - variable 0x26
		btfsc	STATUS,Z	;salta si Z=0
		goto	esigual2		;W=F
		btfsc	STATUS,C	;chequea el bit de acarreo C y salta si el resultado de restar W de F ha sido negativo C=0
		goto	esmenor2	;C=1 entonces W<F
		goto	esmayor2	;C=0 entonces W>F
esigual2	movf	0x64,W	;fuerza valor tope para variable 0x26
		movwf	0x26	;colocar aqui codigo para sealar maximo valor alcanzado
		goto	eebajar
esmenor2	
		goto	eebajar
esmayor2
		movf	0x64,W	;fuerza valor tope minimo para variable 0x26
		movwf	0x26	;colocar aqui codigo para sealar maximo valor alcanzado
		goto	eebajar
eebajar	clrwdt			;graba en eeprom el valor factor de velocidad
		movf	0x26,W
		movwf	0x28	;0x26 a 0x28
		movlw	0x26
		movwf	0x27	;carga la variable 0x27 con la direccion 0x26	
		call	weep
		bcf		PORTA,0	;enciende led A0	
		movlw	0x80	;carga valor para delay corto
		movwf	0x23
		call	delay
		bsf		PORTA,0	;apaga led A0	
		return			;fin rutina bajar ***************************************
				;****************************************rutina que graba un dato en la EEPROM************************************
				;********************************************************
ledA0	bcf		PORTA,0	;enciende led A0     rutina que enciende  y apaga el led A0	
		movlw	0xa0	;carga valor para delay corto
		movwf	0x23
		call	delay
		bsf		PORTA,0	;apaga led A0	
		return
conmuta_led_A0
		movf	PORTA,W	;puerto A a w las lineas sigientes conmutan el led A0 on/off en cada pasada
		movwf	0x2b	;w a variable 0x2b
		movlw	0x01	;carga w con la mascara 00000001
		xorwf	0x2b,W	;w xor f a w
		movwf	PORTA	;w a puerto A
		return				
		 ;********************************************************************
		 ; Binary To BCD Conversion Routine
; This routine converts a 16 Bit binary Number to a 5 Digit
; BCD Number. This routine is useful since PIC16C55 & PIC16C57
; have two 8 bit ports and one 4 bit port ( total of 5 BCD digits)
;
; The 16 bit binary number is input in locations operando_A and
; L_byte with the high byte in operando_B.
; The 5 digit BCD number is returned in 0x34, 0x33 and 0x32 with 0x34
; containing the MSD in its right most nibble.
; Program Memory : 35
; Clock Cycles : 885
; Program: .ASM
; Revision Date:
; 1-13-97 Compatibility with MPASMWIN 1.40
;*******************************************************************;
;			0x67	;operando_A para operaciones matematicas 
;			0x68	;operando_B para operaciones matematicas
;			count equ 0x2a	The 16 bit binary number = FFFF
;			temp equ 0x2b	After conversion the Decimal Number call B2BCD
;			R0 equ 0x34 	in R0,R1,R2 = 06,55,35
;			R1 equ 0x33
;			R2 equ 0x32
B2_BCD  clrwdt
		bcf STATUS,0 ; clear the carry bit
 		movlw .16
 		movwf 0x2a	;variable de uso general
 		clrf 0x32	;variable decenas/unidades
		clrf 0x33	;variable unidades de millar/centenas
		clrf 0x34	;variable 0/decenas de millares
loop16 	rlf 0x67, F
 		rlf 0x68, F
 		rlf 0x32, F
 		rlf 0x33, F
 		rlf 0x34, F
 		decfsz 0x2a, F	;variable de uso general
 		goto adjDEC
 		RETLW 0
adjDEC 	movlw 0x32
 		movwf FSR
 		call adjBCD
 		movlw 0x33
 		movwf FSR
 		call adjBCD
 		movlw 0x34
 		movwf FSR
 		call adjBCD
 		goto loop16
adjBCD 	movlw 3
 		addwf 0,W
 		movwf 0x2b	;variable de uso general
 		btfsc 0x2b,3 ; test if result > 7
 		movwf 0
 		movlw 30
 		addwf 0,W
 		movwf 0x2b	;variable de uso general	
 		btfsc 0x2b,7 ; test if result > 7
 		movwf 0 ; save as MSD
 		RETLW 0
 ;********************************************************************
						; Binary To BCD Conversion Routine de la libreria matematica de microchip
						; Program Memory : 10
						; Clock Cycles : 81 (worst case when W = 63 Hex )
						; ( i.e max Decimal number 99 )
						; Program: BIN8BCD.ASM
						; Revision Date:
						; 1-13-97 Compatibility with MPASMWIN 1.40
BinBCD  bcf		INTCON,GIE	;habilita o no la interrupcion global
		clrf 	0x32	;decenas
		movwf 	0x31	;unidades
gtenth 	clrwdt
		movlw 	0x0a
		subwf 	0x31,W
		BTFSS 	STATUS,C
		goto 	over
		movwf	0x31
		incf 	0x32,F
		goto 	gtenth
over 	bsf		INTCON,GIE	;habilita o no la interrupcion global 
		retlw 	0x00
compara2
		clrwdt			;rutina que compara 2 numeros y devuelve el resultado en W W=0 A menor que B, W=1 A=B, W=2 A mayor que B 
		movf	0x67,W	;carga W con el operando_A
		subwf	0x68,W	;resta W del  operando_B
		btfsc	STATUS,Z	;salta si Z=0
		goto	igual		;W=F 
		btfsc	STATUS,C	;chequea el bit de acarreo C y salta si el resultado de restar W de F ha sido negativo C=0
		goto	menor	;C=1 entonces W<F operando_A es menor que operando_B
		goto	mayor	;C=0 entonces W>F operando_A es mayor que operando_B
igual	movlw	0x02		;la funcion devuelve el valor 2 en 
		movwf	0x69		;esta variaable
		return
menor	movlw	0x01		;la funcion devuelve el valor 1 en 
		movwf	0x69		;esta variaable
		return
mayor	movlw	0x03		;la funcion devuelve el valor 3 en 
		movwf	0x69		;esta variaable
		return
rc_bloque				;rutina para la carga y copia de variables en bloque desde la eeprom
		clrwdt
		movf	0x65,W	;carga w con la primera posicion de eeprom a leer
		movwf	FSR		;carga el FSR con la primera posicion a copiar a ram
		bsf		STATUS,5	;
		bcf		STATUS,6	;BANCO1
		movwf	EEADR	;W a EEADR
		bsf		EECON1,0	;activar lectura eeprom
		movf	EEDATA,W ;W se carga con el dato eeprom leido
		bcf		STATUS,5
		bcf		STATUS,6	;BANCO0 
		movwf	INDF	;W al registro indirecto INDF
		movf	0x65,W	;carga W para comprobar si se alcanzo el tope
		subwf	0x66,W	;valor tope
		btfsc	STATUS,Z	;salta si no se alcanzo el tope
		return				;terorna al completarse el bloque
		incf	0x65	;se incrementa el puntero del bloque hasta que llegue al tope
		goto 	rc_bloque	;comienza de nuevo con otra direccion						
graba_bloque			;rutina que graba un bloque de datos ram a eeprom
		movf	0x65,W	;carga w con la primera posicion de memoria a grabar en eeprom, contenida en esta variable
		movwf	FSR		;copia W al FSR
		movwf	0x27	;carga la variable 0x27 con la direccion a grabar 	
		movf	INDF,W	;carga W con el registro INDF (que contiene el valor apuntado por el FSR)
		movwf	0x28	;W a 0x28 
		bsf		0x2d,4	;activa el flag de permiso de escritura en eeprom por software
		call	weep	;llama a la rutina de escritura en eeprom
		movf	0x65,W	;carga w con para comprobar si se alcanzo el tope
		subwf	0x66,W	;valor tope
		btfsc	STATUS,Z	;salta si no se alcanzo el tope
		return				;retorna al completarse la grabacion del bloque
		incf	0x65	;se incrementa el puntero del bloque hasta que llegue al tope
		goto 	graba_bloque	;comienza de nuevo con otra direccion
weep	clrwdt			;rutina que graba un dato en la EEPROM
		btfss	0x2d,4	;comprueba el bit flag de permiso de escritura en eeprom por software
		return			;si el programa no lo puso a 1 antes de llamar esta rutina, sale inmediatamente para evitar escrituras por mal funcionamiento del software
		btfsc	0x2d,6	;comprueba el bit flag de error de escritura en eeprom 
		return			;si esta a 1 se produjo un error de escritura eeprom, sale inmediatamente para evitar escrituras erroneas
		bcf		0x2d,4	;desactiva el flag de permiso de escritura en eeprom por software
		movwf	0x24	;descarga W en la variable 0x24
		movf	INTCON,W	;guarda INTCON
		movwf	0x20	;a la variable 0x20
		bcf		INTCON,GIE	;Prohibe interrupciones
		movf	0x27,W	;carga w con la variable 0x27 direccion a escribir
		bcf		STATUS,6
		bsf		STATUS,5	;BANCO 1
		bsf		EECON1,2	;habilitar escritura de la eeprom
		movwf	EEADR	;w a eeadr
		bcf		STATUS,6
		bcf		STATUS,5	;BANCO 0
		movf	0x28,W	;carga w con la variable 0x28 dato a escribir
		bcf		STATUS,6
		bsf		STATUS,5	;BANCO 1
		movwf	EEDATA	;w a eedata	dato a escribir
		movlw	0x55
		movwf	EECON2	;se escribe 0x55 en EECON2
		movlw	0xaa	
		movwf	EECON2	;se escribe 0xaa en EECON2
		bsf		EECON1,1	;comienza la escritura
fff		clrwdt			;verificar escritura
		btfsc	EECON1,1	;salto si fin de escritura
		goto	fff
		bcf		STATUS,6	;verificar escritura en EEPROM
		bcf		STATUS,5	;BANCO 0
		movf	0x28,W	;carga w con variable 0x28
		bcf		STATUS,6
		bsf		STATUS,5	;BANCO 1
		bsf		EECON1,0	;activar lectura
		subwf	EEDATA,W 	;resta w de EEDATA
		bcf		STATUS,6
		bcf		STATUS,5	;BANCO 0
		btfss	STATUS,Z	;comprobar si es cero
		bsf		0x2d,6		;pone a 1 el flag de error de escritura eeprom
  		movf	0x20,W	;carga la variable 0x20 en W
		movwf	INTCON	;y descarga W en INTCON		
		movf	0x24,W	;restaura W
		return			;fin rutina escritura en eeprom




				;ALGORITMOS VARIOS

				;Esta rutina hace uso del TMR0 y su preescaler para discriminar una duracin mnima del pulso de entrada en el puerto B0
				;es un automatismo que ajusta el preescaler del TMR0, el pulso debe durar al menos lo que dura el TMR0 en desbordarse, si dura menos el preescaler
				;es aumentado y as sucesivamente
		;btfsc	PORTB,0	;salta si el PUERTO B0 esta a 0 el pulso que provoco la interrupcion debe mantenerse unos 14 micro segundos(lo que tarda en llegar aqui)
		;goto	mpq		;si no la interrupcion no hace nada. Esto es para evitar ruido
		;btfsc	INTCON,T0IF	;salta si el flag de iterrupcion del TIMER0 esta a 0 no se aceptaran pulsos menores que el TIMER0(preescaler)---------------------
		;goto	mpq		;salta el proceso de preescaler automatico
		;incf	0x7b,F		;incrementa la variable preescaler TMR0
		;movlw	0x08		;carga W con el valor que no debe superarse
		;subwf	0x7b,W		;y lo resta de la variable para comprobar si son iguales
		;btfsc	STATUS,Z	;combrueba el resultado de la operacion
		;clrf	0x7b		;si son iguales se pone a 0 la variable preescaler TMR0
		;movlw	0xf8	;carga W con una mascara para cambiar los 3 bit menos significativos
		;bsf		STATUS,5
		;bcf		STATUS,6	;BANCO1
		;andwf	OPTION_REG,W	;del registro OPTION_REG que son los que manejan el preescaler de TIMER0
		;bcf		STATUS,5
		;bcf		STATUS,6	;BANCO0 
		;iorwf	0x7b,W			;hace un OR con el resultado de la anterior operacion
		;bsf		STATUS,5
		;bcf		STATUS,6	;BANCO1
		;movwf	OPTION_REG		;deja el nuevo valor en el registro
		;bcf		STATUS,5
		;bcf		STATUS,6	;BANCO0----------------------------------------------------------------------------------------------------------------------------- 
	;mpq						;continua el curso del programa
tabla
		return	;para que no de error al compilar
;tabla	movlw	0x0f	;fuerza un valor max de 16
	;	andwf   0x55,W	;trunca el dato para no desbordar la tabla
	;	addwf   PCL,F	;suma W al PCL para obtener un dato
	;	retlw   0x1f	;
	;	retlw   0x1f	; enero 31
	;	retlw   0x1c	; febrero 28
	;	retlw   0x1f	; marzo 31
	;	retlw   0x1e	; abril 30
	;	retlw   0x1f	; mayo 31
	;	retlw   0x1e	; junio 30
	;	retlw   0x1f	; julio 31
	;	retlw   0x1f	; agosto 31
	;	retlw   0x1e	; septiembre 30
	;	retlw   0x1f	; octubre 31
	;	retlw   0x1e	; noviembre 30
	;	retlw   0x1f	; diciembre 31
	;	retlw   0x1e	;
	;	retlw   0x1f	;
	;	retlw   0x1e	;





		;fin rutinas***********************************************************************************************************************
					;a continuacion el contenido que se grabara en la eeprom en decimal
		org		0x2100	;posicion de eeprom
		de		.40,.40,.41,.42,.41,.41,.43,.43,.52,.52,.54,.55,.56,.52,.55,.53
		de		.44,.15,.48,.1,.45,.46,.47,.49,.57,.57,.58,.58,.58,.59,.59,.59
		de		.16,.17,.18,.19,.20,.10,.21,.22,.28,.29,.30,.2,.31,.2,.7,.53
		de		.28,.29,.28,.29,.33,.33,.34,.76,.66,.61,.62,.66,.63,.62,.65,.65
		de		0x80,0xe8,.67,.67,.0,.2,.3,.4,.0,.68,.5,.69,.77,.70,.75,.14
		de		.0,0x00,.0,0x12,.25,.8,.10,.00,.00,.62,.63,.64,.65,.8,.9,.11
		de		.00,.13,.35,.26,.26,.26,.26,.26,.71,.72,.73,.75,.0,.73,.1,.2
		de		.15,0x0a,0x00,0x13,0x00,.0,.0,.115,.81,.1,.81,.82,.83,.81,.81,.39
		
		END



